using System;
using System.Text;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples
{
    public partial class SetTheHoverPopupOfAMarker : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                ClusterMarkerStyle clusterMarkerStyle = new ClusterMarkerStyle(20, 1024, 768);
                clusterMarkerStyle.MarkerStyle = new PointMarkerStyle();

                InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");
                RectangleShape extent = null;

                for (var i = 0; i < 1000; i++)
                {
                    Random random = new Random(i.GetHashCode());
                    Feature feature = new Feature(-95.28109 + random.Next(1, 10), 38.95363 + random.Next(1, 5));
                    if (extent == null)
                    {
                        extent = feature.GetBoundingBox();
                    }
                    else
                    {
                        extent.ExpandToInclude(feature.GetBoundingBox());
                    }
                    markerOverlay.Features.Add(feature);
                }

                markerOverlay.Features.Add("LA", new Feature(-118.28109, 34.505363));
                markerOverlay.ZoomLevelSet.ZoomLevel01.CustomMarkerStyle = clusterMarkerStyle;
                markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.CustomOverlays.Add(markerOverlay);

                Map1.CurrentExtent = extent;
            }
        }
    }
}
